import java.io.*;
import java.net.*;

class JChartDataset
{
  JChartDatasetElement dati;
  int nelem,ncolumns;
  JChartDataset(File file,int ncol)
    {
      try{setup_things(new FileInputStream(file),ncol);} catch (Exception e) {System.out.println("ERROR: DATA NOT FOUND");}
    }
  JChartDataset(URL conn,int ncol)
    {
      try{setup_things(conn.openStream(),ncol);} catch (Exception e) {System.out.println("ERROR: DATA NOT FOUND");}
    }
  JChartDataset(String filename,int ncol)
    {
      try{setup_things(new FileInputStream(filename),ncol);} catch (Exception e) {System.out.println("ERROR: DATA NOT FOUND");}
    }
  JChartDataset(InputStream is,int ncol)
    {
      setup_things(is,ncol);
    }
  void setup_things(InputStream is,int ncol)
    {
      int finito=0;
      JChartDatasetElement e;
      String r;
      DataInputStream dis=new DataInputStream(is);
      ncolumns=ncol;
      dati=null;
      nelem=0;
      finito=0;
      r=null;
      e=null;
      while(finito==0)
        {
          try {r=dis.readLine();} catch(IOException exc) {finito=1;}      
          if(r!=null)
            {
              if(e==null)
                {
                  e=new JChartDatasetElement(r,ncolumns);
                  dati=e;
                  nelem+=1;
                }
              else
                {
                  e.next=new JChartDatasetElement(r,ncolumns);
                  e=e.next;
                  nelem+=1;
                }
            }
          else
            finito=1;
        }
      try {is.close();} catch(IOException exc) {System.out.println("IO error on close");}    
    }
}

