import java.io.*;
import java.awt.*;

class JChartTest extends Frame
{
  JChart jc;
  Button dismissButton;
  public static void main(String[] args)
    {
      if(args.length<3)
	{
	  System.err.println("usage: java JChartTest filename no_of_columns type");
	  System.err.println("where type::= {HISTOGRAM,PIE,LINE,POINTS,LINEPOINTS}");
	  System.exit(1);
	}
      JChartTest f=new JChartTest(args[0],Integer.valueOf(args[1]).intValue(),args[2]);
      f.show();
    }
  JChartTest(String file,int column,String type)
    {
      Font f=new Font("Sansserif",Font.PLAIN,12);
      Font f1=new Font("Sansserif",Font.ITALIC,12);
      Font f2=new Font("Sansserif",Font.BOLD,14);
      Color[] cs={Color.blue,Color.red,Color.green};
      jc=new JChart(file,column,file,350,300,60,20,10,10,type,"x-axis","y-axis",
	       f,f2,f1,80,1,1,0,Color.white,Color.black,Color.black,cs,true,true);
      dismissButton=new Button("Dismiss");
      add(jc,"Center");
      add(dismissButton,"South");
      pack();
      show();
    }
  public boolean handleEvent(Event event) 
    {
      if (event.id == Event.WINDOW_DESTROY)
         System.exit(0);
      return super.handleEvent(event);
    }
  public boolean action(Event event, Object arg) 
    {
      if (event.target==dismissButton)
	{
	  System.exit(0);
        }
      return false;
    }
}

